<?php

class IMWB_Covert_Video_Content_youtube {

   var $super = null;
   var $module_name = "youtube";
   var $plugin_name = "";
   var $plugin_url = "";
   var $options = Array();
   var $ytcategory_options = array('xx' => 'All Categories',
                                   '1' => 'Film & Animation',
									'2' => 'Autos & Vehicles',
									'10' => 'Music',
									'15' => 'Pets & Animals',
									'17' => 'Sports',
									'18' => 'Short Movies',
									'19' => 'Travel & Events',
									'20' => 'Gaming',
									'21' => 'Videoblogging',
									'22' => 'People & Blogs',
									'23' => 'Comedy',
									'24' => 'Entertainment',
									'25' => 'News & Politics',
									'26' => 'Howto & Style',
									'27' => 'Education',
									'28' => 'Science & Technology',
									'29' => 'Nonprofits & Activism',
									'30' => 'Movies',
									'31' => 'Anime/Animation',
									'32' => 'Action/Adventure',
									'33' => 'Classics',
									'34' => 'Comedy',
									'35' => 'Documentary',
									'36' => 'Drama',
									'37' => 'Family',
									'38' => 'Foreign',
									'39' => 'Horror',
									'40' => 'Sci-Fi/Fantasy',
									'41' => 'Thriller',
									'42' => 'Shorts',
									'43' => 'Shows',
									'44' => 'Trailers');

   /**
    * The constructor is executed when the class is instatiated and the plugin gets loaded.
    * @return void
    */
   function IMWB_Covert_Video_Content_youtube(&$super) {
      $this->super = $super;
      $this->plugin_name = $super->plugin_name;
      $this->plugin_url = $super->plugin_url;
      $this->options = $this->get_admin_options();

   }

   function get_admin_options() {
   	$adminOptions = array('active' => 'N',
   	                      'posthours' => '4',
   	                      'postcount' => '5',
   	                      'categories' => '',
   	                      'catselecttype' => 'R',
   	                      'ignorekw' => 'N',
   	                      'ytcat' => 'xx',
   	                      'ytorderby' => 'relevance',
   	                      'ytlang' => 'xx',
   	                      'ytsafesearch' => 'none',
   	                      'lastcat' => 0,
   	                      'lastrun' => 0);

   	$devOptions = get_option($this->plugin_name."-".$this->module_name."-AdminOptions");
   	if (!empty($devOptions)) {
   		foreach ($devOptions as $key => $option)
   			$adminOptions[$key] = $option;
   	}
   	update_option($this->plugin_name."-".$this->module_name."-AdminOptions", $adminOptions);
   	return $adminOptions;
   }

   function is_active(){

      return $this->options['active'] == 'Y' ? true : false;
   }

   function is_ready_to_post() {

      $lastrun = $this->options['lastrun'];
      if($lastrun > 0 && ($this->options['lastrun']+($this->options['posthours']*3600)) >current_time('timestamp') )
            return false;

      $this->options['lastrun'] = current_time('timestamp');

      update_option($this->plugin_name."-".$this->module_name."-AdminOptions", $this->options);

      return true;
   }

   function init_admin_menu() {
      $view_hook_name = add_submenu_page($this->plugin_name . '-admin-menu', 'Covert Video Content YouTube Settings', 'YouTube', 'manage_options', $this->plugin_name . '-admin-menu-'.$this->module_name, array(&$this, 'load_options_page'));

      return  $view_hook_name;
   }

   function load_options_page() {
   	// Include the HTML from a separate file to keep the plugin class clean
   	require "youtube_options_page.php";
   }

   function do_posts($keyword, $numPosts = 0, $category_input = null, $cats_to_post_to = null, $tags_input = null, $post_status = null, $rating = null, $view_count = null, $keyword_search = null, $use_api_viewCount = null) {
      global $wpdb;

      if($numPosts == 0)
         $numPosts = rand(1, $this->options['postcount']);
      $numCreated = 0;
      $maxResults = 50;

      $url_keyword = urlencode(trim($keyword));
      $q_param = "&q=".$url_keyword;

      if(!empty($keyword_search))
         $q_param = '';
      elseif($this->options['ignorekw'] == 'Y')
         $q_param = '';


	  //youtube categories IDS: 1=Film & Animation,2=Autos & Vehicles,10=Music,15=Pets & Animals,17=Sports,18=Short Movies,19=Travel & Events,20=Gaming,21=Videoblogging,22=People & Blogs,23=Comedy,24=Entertainment,25=News & Politics,26=Howto & Style,27=Education,28=Science & Technology,29=Nonprofits & Activism,30=Movies,31=Anime/Animation,32=Action/Adventure,33=Classics,34=Comedy,35=Documentary,36=Drama,37=Family,38=Foreign,39=Horror,40=Sci-Fi/Fantasy,41=Thriller,42=Shorts,43=Shows,44=Trailers

      if($this->options['ytcat'] != 'xx' )
         $category_param = "&type=video&videoCategoryId=".$this->options['ytcat'];
      else
         $category_param = "";

      if($this->options['ytlang'] != 'xx' ) {
         $lang = $this->options['ytlang'];
         if($lang == "zh-cn") {$lang = "zh-Hans";}
         if($lang == "zh-tw") {$lang = "zh-Hant";}
         $lr_param = "&relevanceLanguage=".$lang;
      }
      else
         $lr_param = "";

      // Loop through the result pages until we create enough posts
      $page = 0;
	$key = $this->options['youtube_api_key'];
      do {

         $startIndex = ($page * $maxResults)+1;
			//echo " $page == $maxResults == $startIndex <br>";
         //$requestURL = "http://gdata.youtube.com/feeds/api/videos?orderby=".$this->options['ytorderby']."&start-index=".$startIndex."&max-results=".$maxResults."&format=5&safeSearch=".$this->options['ytsafesearch']."&v=2".$q_param.$category_param.$lr_param;

		 $requestURL = "https://www.googleapis.com/youtube/v3/search?key=".$this->options['youtube_api_key']."&part=snippet&order=".$this->options['ytorderby']."&maxResults=".$maxResults."&safeSearch=".$this->options['ytsafesearch'].$q_param.$category_param.$lr_param;



//
     //echo "<br>URL: $requestURL<br>";
//     echo "Num Posts".$numPosts."<br>";
//     echo "==================================<br><br>";

      $resultxml = $this->yt_request($requestURL);
      //print_r($resultxml);die();
      if(is_array($resultxml) AND !empty($resultxml["error"])) {return $resultxml;}

      if ($startIndex > 50) {
      	$return["error"]["module"] = "Youtube";
      	$return["error"]["reason"] = "API fail";
      	$return["error"]["message"] = "Error: The Youtube module can only return the first 50 videos per keyword. Please choose a different keyword or reset your post counter.";
      	return $return;
      }

      if ($resultxml === False) {
      	$return["error"]["module"] = "Youtube";
      	$return["error"]["reason"] = "API fail";
      	$return["error"]["message"] = "Youtube API request did not work.";
      	return $return;
      }

	  if (isset($resultxml->error->errors) AND count($resultxml->error->errors)>0) {
      	$return["error"]["module"] = "Youtube";
		$return["error"]["reason"] = "Youtube API Returned Following Errors";
		$return["error"]["message"] = "";
		foreach ($resultxml->error->errors as $k=>$v)
			$return["error"]["message"] .= "<br><b>D:</b>".$v->domain.", <b>R:</b>".$v->reason.", <b>M:</b>".$v->message.",<br>";
      	return $return;
      }



      if (!isset($resultxml->items) OR count($resultxml->items)==0) {
         $return["error"]["module"] = "Youtube";
			$return["error"]["reason"] = "No content";
			$return["error"]["message"] = "No (more) Youtube videos found.";
			return $return;
      }

//		$scount = 0;

	   foreach($resultxml->items as $entry) {

//			$scount++;
//			if($start > $scount) {continue;}

      if(!isset($entry->id->videoId))
        continue;
      else
			   $video_id = (string)$entry->id->videoId;

			$desc = (string)$entry->snippet->description;
			//echo $video_id."<br>";
			//echo $desc."<br>";
			$post_title = (string)$entry->snippet->title;

			//$thumbnailurl = $entry->snippet->thumbnails->default->url;
			//$thumbnail = '<img alt="'.$title.'" src="'.$thumbnailurl.'" />';

			//$thumbnailurl_med = $entry->snippet->thumbnails->medium->url;
			//$thumbnail_med = '<img alt="'.$title.'" src="'.$thumbnailurl_med.'" />';

			$thumbnailurl_lrg = $entry->snippet->thumbnails->high->url;
			//$thumbnail_lrg = '<img alt="'.$title.'" src="'.$thumbnailurl_lrg.'" />';

			$temp = $this->youtube_getfulldesc($video_id, $key);
			//print_r($temp);die();
			$fulldesc = $temp['desc'];
			//echo $fulldesc;die();
			$statistics = $temp['stats'];
			if(!empty($fulldesc)) {$desc = $fulldesc;}


            //$media = $item->children('http://search.yahoo.com/mrss/');

            //$yt = $item->children('http://gdata.youtube.com/schemas/2007');
            //$statistics = $yt->statistics->attributes();

            //$yt = $media->children('http://gdata.youtube.com/schemas/2007');
            //$video_id = (string)$yt->videoid;

            // Get the title
            //$post_title = (string)$media->group->title;
            //$post_title = (string)$media->group->title;

            // Check for exisintg post
			//print_r($video_id);
   			$results = $wpdb->get_row( $wpdb->prepare("SELECT post_id FROM {$wpdb->postmeta} WHERE meta_key = %s AND meta_value = %s", 'imwb_ctc_youtube_id', trim($video_id)) );

   			if(count($results) > 0)
   			   continue;

   			// Get the Video data
   			/*
			$videoData = $this->yt_single_video_request($video_id);
   			if(!empty($videoData["error"])) {return $videoData;}

   			if ($videoData === False) {
   				$return["error"]["module"] = "Youtube";
   				$return["error"]["reason"] = "API fail";
   				$return["error"]["message"] = "Youtube Video Data API request did not work.";
   				return $return;
   			}

   			$media = $videoData->children('http://search.yahoo.com/mrss/');

            // Get the description
            $desc = (string)$media->group->description;
   			 */
            // get category
            if(empty($cats_to_post_to))
               $post_category = $this->super->get_post_categories(htmlspecialchars(stripslashes($this->options['categories'])),$this->options['catselecttype'], $keyword);
            else
               $post_category = $this->super->get_post_categories($category_input ,$cats_to_post_to, $keyword);


            // Get The Tags
            if(empty($tags_input)) {
               $post_tags = array();
               if($this->super->options['createtags'] == 'Y') {
                  $post_tags = $this->super->get_tags($post_title);
               }
            }
            else
               $post_tags = $tags_input;

            // Save Post
            $post_content = wpautop($desc);
            $post_type = "post";
            $post_date = current_time('mysql');
            $post_date_gmt = current_time('mysql', 1);
            $post_author = $this->super->get_random_author();
            if(empty($post_status))
               $post_status = $this->super->options['posttype'] == '0' ? 'publish' : 'draft';

//           echo "Title: $post_title<br>Content: $post_content<br>CatId:";
//           var_dump($post_category);
//           echo "<br>AuthorId:$post_author<br>Video Id:$video_id<br>";

           	$post_data = compact('post_content','post_title','post_date','post_date_gmt','post_author','post_category', 'post_status', 'post_type');

            $post_data['tags_input'] = implode(',', $post_tags);
            $post_data = add_magic_quotes($post_data);
            $postId = wp_insert_post($post_data);
            if (is_wp_error($postId)) {
               $return["error"]["module"] = "YouTube ($keyword)";
               $return["error"]["reason"] = "Error Inserting Post";
               $return["error"]["message"] = $postId->get_error_message();
               return $return;
            }

            // Store the Video ID so we don't post duplicates
            update_post_meta( $postId , 'imwb_ctc_youtube_id', trim($video_id) );
            // Store the video
            update_post_meta( $postId , 'imwb_videopress_post_video_url', trim($video_id) );
            update_post_meta( $postId , 'imwb_videopress_post_video_type', 'Y' );

            // Set the thumbnail
            $this->super->generate_thumbnail($postId, 'Y', trim($thumbnailurl_lrg));

            // Set the view count

            if(!empty($use_api_viewCount) && $use_api_viewCount == 'Y' && $statistics->viewCount > 0)
               $vc_value = (int)$statistics->viewCount;
            else if(empty($use_api_viewCount) && $this->super->options['useapivc'] == 'Y' && $statistics->viewCount > 0)
               $vc_value = (int)$statistics->viewCount;
            else {
               if(!empty($view_count))
                  $vc_value = mt_rand($view_count['min'], $view_count['max']);
               else
                  $vc_value = mt_rand($this->super->options['viewsfrom'], $this->super->options['viewsto']);
            }
//         echo "View Count:$vc_value<br>";

            update_post_meta( $postId, '_imwb_videopress_post_video_views', $vc_value);

            // Set the rating
            if(!empty($rating))
               $vr_value = mt_rand($rating['min'], $rating['max']);
            else
               $vr_value = mt_rand($this->super->options['ratingfrom'], $this->super->options['ratingto']);

//         echo "Rating:$vr_value<br>";

            update_post_meta( $postId, '_imwb_videopress_post_video_score', $vr_value);
            update_post_meta( $postId, '_imwb_videopress_post_video_count', '1');
            update_post_meta( $postId, '_imwb_videopress_post_video_rating', $vr_value);
            update_post_meta( $postId, '_imwb_videopress_post_video_imp', 0);
            update_post_meta( $postId, '_imwb_videopress_post_video_clicks', 0);
            update_post_meta( $postId, '_imwb_videopress_post_video_ctr', 0);

            $numCreated++;

            // Comments
            if($this->super->options['addcomments'] == 'Y') {
				$this->do_comments($postId, $video_id, $key);
			}

            if( $numCreated == $numPosts)
               break;
         }


         // Page Loop
         if( $numCreated == $numPosts)
            break;

         $page++;

      } while($page <= 0);

      return $numCreated;
   }

   function youtube_getfulldesc($vid, $key) {
		$video = array();
		$request = "https://www.googleapis.com/youtube/v3/videos?part=snippet,statistics&id=".$vid."&key=".$key;
		//echo $request."<br>";
		$response = wp_remote_get($request);
		  if( is_wp_error( $response ) ) {
			  $return["error"]["module"] = "YouTube";
			  $return["error"]["reason"] = "Error Connecting to YouTube Stat API";
			  $return["error"]["message"] = $response->get_error_message();
			  return $return;
		}


		$pxml = json_decode($response['body']);
		//echo "<pre>";print_r($pxml);echo "</pre>";die();

		if ($pxml === False) {
			return false;
		} else {
			if(isset($pxml->items)) {
				foreach ($pxml->items as $tttt) {
					if (isset($tttt->snippet->description)) {
						$video['desc']= $tttt->snippet->description;
					}
					if (isset($tttt->statistics)) {
						$video['stats']= $tttt->statistics;
					}
				}
				return $video;
			}

			return false;
		}
	}

	function do_comments($postId, $vid, $key) {

	$request = "https://www.googleapis.com/youtube/v3/commentThreads?part=snippet&maxResults=50&videoId=$vid&key=".$key;
	//die($request);
      $response = wp_remote_get($request);
      if( is_wp_error( $response ) ) {
         return $return;
      }

      $comments = json_decode($response['body']);

      if($this->super->options['randcomments'] == 'Y') {
      	$cnum = rand(10,30);
      } else {
      	$cnum = 20; //$commentsCount;
      }

   	$comment_ts = current_time('timestamp');

      $i = 0;
		foreach ($comments->items as $comment) {

			if($i == $cnum)
			   break;

			$comment_post_ID=$postId;
			$comment_ts = $comment_ts + (rand(0, 30) * 60 + rand(0, 59));
			$comment_date = date('Y-m-d H:i:s', $comment_ts);
			$rnd= rand(1,9999);
			$comment_author_email="noreply$rnd@yourdomain.com";
			$comment_author=(string)$comment->snippet->topLevelComment->snippet->authorDisplayName;
			$comment_author_url='';
			$comment_content=trim((string)$comment->snippet->topLevelComment->snippet->textDisplay);
			$comment_type='';
			$user_ID='';
			$comment_approved = 1;
			$commentdata = compact('comment_post_ID', 'comment_date', 'comment_author', 'comment_author_email', 'comment_author_url', 'comment_content', 'comment_type', 'user_ID', 'comment_approved');

			if(strlen($comment_content)>10)
			{
			$comment_id = wp_insert_comment( $commentdata );
			$i++;
			}
		}
   }

   function yt_request($request) {
   	libxml_use_internal_errors(true);

   	$response = wp_remote_get($request);
      if( is_wp_error( $response ) ) {
  	      $return["error"]["module"] = "YouTube";
  	      $return["error"]["reason"] = "Error Connecting to YouTube API";
  	      $return["error"]["message"] = $response->get_error_message();
  	      return $return;
     }

     $pxml = json_decode($response['body']);
     if ($pxml === False) {
   		$emessage = "Failed loading XML, errors returned: ";
   		foreach(libxml_get_errors() as $error) {
   			$emessage .= $error->message . ", ";
   		}
   		libxml_clear_errors();
   		$return["error"]["module"] = "YouTube";
   		$return["error"]["reason"] = "XML Error";
   		$return["error"]["message"] = $emessage;
   		return $return;
   	} else {
   		return $pxml;
   	}
   }

   /*
   function yt_single_video_request($videoid) {
   	libxml_use_internal_errors(true);

      $request = "https://gdata.youtube.com/feeds/api/videos/$videoid?v=2";
//     echo "<br>URL: $request<br>";
//     echo "==================================<br><br>";
   	$response = wp_remote_get($request);
      if( is_wp_error( $response ) ) {
  	      $return["error"]["module"] = "YouTube";
  	      $return["error"]["reason"] = "Error Connecting to YouTube API";
  	      $return["error"]["message"] = $response->get_error_message();
  	      return $return;
     }

     $pxml = simplexml_load_string($response['body']);
     if ($pxml === False) {
   		$emessage = "Failed loading XML, errors returned: ";
   		foreach(libxml_get_errors() as $error) {
   			$emessage .= $error->message . ", ";
   		}
   		libxml_clear_errors();
   		$return["error"]["module"] = "YouTube";
   		$return["error"]["reason"] = "XML Error";
   		$return["error"]["message"] = $emessage;
   		return $return;
   	} else {
   		return $pxml;
   	}
   }
	*/

}


?>
