<?php
if(!defined("ABSPATH"))
	die(); // No direct access plx

function getAuthors( $level ) {
   global $wpdb;
	
	$userIDs = $wpdb->get_col('
			SELECT ID
			FROM '.$wpdb->users.' INNER JOIN '.$wpdb->usermeta.'
			ON '.$wpdb->users.'.ID = '.$wpdb->usermeta.'.user_id
			WHERE '.$wpdb->usermeta.'.meta_key = \''.$wpdb->prefix.'user_level\'
			AND '.$wpdb->usermeta.'.meta_value >= '.$level);
		
	return $userIDs;
}
	
$updateMessage = '';
	
if (isset($_POST['imwb_covertvideocontent_runmodules'])) {
   $this->do_posts(true);
}
else if (isset($_POST['update_imwb_covertvideocontentSettings'])) { 

  $update = Array();

  foreach ($_REQUEST['imwb_covertvideocontent_options'] as $key => $value) {

    if($key == "authors")  
        $update[$key] = implode(',', $value);
    elseif($key == "ratingfrom") 
        $update[$key] = is_numeric($value) && $value >= 0 && $value <= 5  ? $value : 1;
    elseif($key == "ratingto") 
        $update[$key] = is_numeric($value) && $value >= 0 && $value <= 5  ? $value : 5;
    elseif($key == "viewsfrom") 
        $update[$key] = is_numeric($value) && $value >= 0 ? $value : 200;
    elseif($key == "viewsto") 
        $update[$key] = is_numeric($value) && $value >= 0 ? $value : 500;
    else
		$update[$key] = trim($value);
	}
      
	update_option($this->plugin_name."-AdminOptions", $update);
	$this->options = $update;
	
	// If generate random authors then create some
	$authorsToGen = intval($_REQUEST['imwb_covertvideocontent_options']['genauthors']);
	if($authorsToGen > 0) {
	
	   // Get the first names into an array
	   $firstnames = explode(',', htmlspecialchars(stripslashes($this->options['firstnames'])));
	   $totfirstnames = count($firstnames)-1;
	   $lastnames = explode(',', htmlspecialchars(stripslashes($this->options['lastnames'])));
	   $totlastnames = count($lastnames)-1;
	   	   
	   $created = 0;
	   $failed = 0;

      while($created < $authorsToGen && $failed < 10) {
       
         $firstname = $firstnames[rand(0, $totfirstnames)];
         $lastname = $lastnames[rand(0, $totlastnames)];
         
         $username = strtolower( $firstname.$lastname);
         if (get_user_by('login', $username) !== false) {
            $failed++;
            continue;
         }

         $rnd= rand(1,9999);         
         $user_data = array(
               'user_pass' => $this->generate_password(15),
               'user_login' => $username,
               'user_nicename' => $firstname.' '.$lastname,
               'user_email' => $username.$rnd.'@yourdomain.com',
               'display_name' => $firstname.' '.$lastname,
               'first_name' => $firstname,
               'last_name' => $lastname,
               'user_registered' => date('Y-m-d H:i:s', current_time('timestamp')),
               'role' => 'author');

         $user_id = wp_insert_user($user_data);
         
         if (is_wp_error($user_id)) 
            $failed++;
         else 
            $created++;
         
      }
      if($created > 0)
         $updateMessage .= '<div class="imwb_cabar_active_panel"><p><strong>Create '.$created.' New Authors</strong></p></div>';
	}

   $updateMessage .= '<div class="imwb_cabar_active_panel"><p><strong>Settings Updated </strong></p></div>';
} 

$post_options = array(
	'0' => array('label' => __('Published', 'imwb_covertvideocontent')),
	'1' => array('label' => __('Draft', 'imwb_covertvideocontent'))
);

$yesno_options = array(
	'1' => array('label' => __('Yes', 'imwb_videopress')),
	'0' => array('label' => __('No', 'imwb_videopress'))
);

$leftright_options = array(
	'1' => array('label' => __('Left', 'imwb_videopress')),
	'0' => array('label' => __('Right', 'imwb_videopress'))
);

$abovebelow = array(
	'1' => array('label' => __('Above', 'imwb_videopress')),
	'0' => array('label' => __('Below', 'imwb_videopress'))
);
?>	
<div class="wrap">
<div id="imwb_plugin_header">
<a href="http://imwealthbuilders.com" target="_blank"><img src="<?php echo $this->plugin_url. '/pages/images/imwblogo.png';?>"></a>
<span id="imwb_plugin_header_link"><a href="http://imwealthbuilders.com/newplugins" target="blank">Click Here To See Our Latest WP Plugins</a></span>
<h2>Covert Video Content</h2>
<div style="clear: both"></div>
</div>
<?php echo $updateMessage;?>
<div id="imwb_plugin_options_editor">
<div class="icon32" id="icon-link-manager"><br></div><h2>Settings - <small><a href="http://covertcontent.com/video/help/std_help.html" target="_blank">Click Here For Help</a></small></h2>
<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
<div class="imwb_cabar_active_panel">
<div class="sub_panel right">
<h4>Modules</h4>
<table>
<thead>
<tr><th>Available</th><th>Auto Blogging</th><th>Last Run</th><th>Next Run</th></tr>
</thead>
<tbody>
<?php 
$errors = "";
foreach ($this->available_modules as $moduleName => $moduleClass) {
   $active = $moduleClass->is_active();
   if($active[0] == 'x') continue;
   $active = $active ? "Yes" : "No";
   $moduleOptions = $moduleClass->get_admin_options();
   echo "<tr><td>$moduleName</td><td align='center'>$active</td>";
   if ($moduleOptions['lastrun'] > 0 && $active == 'Yes') {
      echo "<td>";
      echo date_i18n(get_option('date_format') ,$moduleOptions['lastrun']).' at ';
      echo date_i18n(get_option('time_format') ,$moduleOptions['lastrun']);
      echo "</td>";
      echo "<td>";
      echo date_i18n(get_option('date_format') ,$moduleOptions['lastrun']+($moduleOptions['posthours']*3600)).' at ';
      echo date_i18n(get_option('time_format') ,$moduleOptions['lastrun']+($moduleOptions['posthours']*3600));
      echo "</td>";

   }
   else 
      echo "<td> - </td><td> - </td>";

   $errorMsg = get_option($this->plugin_name."-".$moduleName."-errors");
   if($errorMsg != "")
      $errors .= '<p>'.$errorMsg.'</p>';
}
?>
</tbody>
</table>
</div>
<p><strong>Welcome to the Covert Video Content admin area.</strong></p>
<p>In order to make the plugin work
<ol>
<li>Enter the keywords you want to create automatic posts for on your blog. You can enter up to 100 Keywords. With each keyword on a separate line.</li>
<li>Configure the defaults for how the content is acquired and posted to your blog.</li>
<li>Configure the various content modules to set how the module will run and set them active</li>
</ol>
</p>
<p><strong>Next Auto Blogging Schedule</strong></p>
<p>Next scheduled run of active auto blogging modules is
<?php 
$nextRun = wp_next_scheduled($this->plugin_name.'_cron_event');
echo date_i18n(get_option('date_format') ,$nextRun+get_option( 'gmt_offset' ) * 3600).' at ';
echo date_i18n(get_option('time_format') ,$nextRun+get_option( 'gmt_offset' ) * 3600);
?>
 <input class="button-primary" type="submit" name="imwb_covertvideocontent_runmodules" value="<?php _e('Run Now', 'imwb_covertvideocontent') ?>" />
 </p>
</div>
<?php 
if($errors != '') {
   echo '<div class="imwb_cabar_active_panel errormsg"><p><strong>The following error(s) occured durring the last run</strong></p>';
   echo $errors;
   echo '</div>';
}
?>

<div class="sub_panel left" style="width:480px">
<h4>Keywords</h4>
<div>
<p>Enter one keyword/phrase per line. They will be selected in order for each posting run. Enclose keyword/phrase in double quotes (") for an exact search</p>
<textarea id="imwb_covertvideocontent_options[keywords]" name="imwb_covertvideocontent_options[keywords]" rows='29'>
<?php echo htmlspecialchars(stripslashes($this->options['keywords'])) ?>
</textarea>
</div>
</div>

<div class="sub_panel left" style="width:570px">
<h4>Post Creation</h4>
<div>
<h3>New Post Status</h3>
When adding new posts set status to <select id="imwb_covertvideocontent_options[posttype]" class="regular-text" type="text" name="imwb_covertvideocontent_options[posttype]" />
<?php 
 foreach ($post_options as $key => $value) {
    $selected = ($this->options['posttype'] == $key) ? " selected" : "";
    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
 }
?>
</select>
<h3>Automatically create Tags</h3>
<p>Select to have tags created automatically, tags 3 characters or less are ignored <input id="imwb_covertvideocontent_options[createtags]" type="checkbox" name="imwb_covertvideocontent_options[createtags]" value="Y" <?php echo $this->options['createtags'] == "Y" ? "checked='Yes'" : "" ?> /></p>
<h3>Don't Create These Tags</h3>
<textarea id="imwb_covertvideocontent_options[badtags]" name="imwb_covertvideocontent_options[badtags]" cols=80 rows=5>
<?php echo $this->options['badtags'] ?>
</textarea>
<h3>Comments</h3>
<p>Add available comments to post <input id="imwb_covertvideocontent_options_addcomments" type="checkbox" name="imwb_covertvideocontent_options[addcomments]" value="Y" <?php echo $this->options['addcomments'] == "Y" ? "checked='Yes'" : "" ?> /><br>Randomize number of comments added to vary the number of comments per post. <input id="imwb_covertvideocontent_options_randcomments" type="checkbox" name="imwb_covertvideocontent_options[randcomments]" value="Y" <?php echo $this->options['randcomments'] == "Y" ? "checked='Yes'" : "" ?> /></p>
<?php if (ini_get('allow_url_fopen') == true && $this->current_theme == "Covert VideoPress Theme") { ?>
<h3>Store Video Thumbnail Images Locally</h3>
<p>Select to have video thumbnail images stored locally on your server rather than hotlinked to their source <input id="imwb_covertvideocontent_options[storeimg]" type="checkbox" name="imwb_covertvideocontent_options[storeimg]" value="Y" <?php echo $this->options['storeimg'] == "Y" ? "checked='Yes'" : "" ?> /></p>

<h3>Initial Video Rating</h3>
<p>Set the initial video rating between <input id="imwb_covertvideocontent_options_ratingfrom" type="text" name="imwb_covertvideocontent_options[ratingfrom]" value="<?php echo $this->options['ratingfrom'] ?>" size="3"> and  <input id="imwb_covertvideocontent_options_ratingto" type="text" name="imwb_covertvideocontent_options[ratingto]" value="<?php echo $this->options['ratingto'] ?>" size="3"> (Min 0 - Max 5)</p>
<h3>Initial View Count</h3>
<p>Use View Count from API if available <input id="imwb_covertvideocontent_options_useapivc" type="checkbox" name="imwb_covertvideocontent_options[useapivc]"  value="Y" <?php echo $this->options['useapivc'] == "Y" ? "checked='Yes'" : "" ?> > </p>
<p>Set the initial video view count between <input id="imwb_covertvideocontent_options_viewsfrom" type="text" name="imwb_covertvideocontent_options[viewsfrom]" value="<?php echo $this->options['viewsfrom'] ?>" size="3"> and  <input id="imwb_covertvideocontent_options_viewsto" type="text" name="imwb_covertvideocontent_options[viewsto]" value="<?php echo $this->options['viewsto'] ?>" size="3"></p>

<?php } ?>
</div>
</div>

<div class="sub_panel left" style="width:480px; clear: left;">
<h4>Author For Posts</h4>
<div>
<P>Select the author/s to assign to each post and one will be chosen randomly. If none selected the Admin will be used.</P>
<select size="10"  multiple="multiple"  style="width:455px; height:200px;" name="imwb_covertvideocontent_options[authors][]" id="imwb_covertvideocontent_options[authors]" >
<?php 
   $currentAuthors = explode(",", htmlspecialchars(stripslashes($this->options['authors'])) );
   $authors = getAuthors('2');
	foreach ( $authors as $author ) {
   	$author_info = get_userdata($author);

      echo "<option value='" . $author . "'";
      if( in_array($author , $currentAuthors ) )
      {
      	echo " selected='selected' ";
      }
      echo " >" .$author_info->display_name. "</option>";
	}
?>
</select>
<br>
<a href="javascript:void(0)" onclick="imwb_covertvideocontent_selectAll(document.getElementById('imwb_covertvideocontent_options[authors]'))"><?php _e('Select All','imwb_covertvideocontent'); ?></a> / <a href="javascript:void(0)" onclick="imwb_covertvideocontent_unselectAll(document.getElementById('imwb_covertvideocontent_options[authors]'))"><?php _e('Unselect All','imwb_covertvideocontent'); ?></a>
</div>
</div>

<div class="sub_panel left" style="width:570px">
<h4>Author Creation</h4>
<table>
<tr><td colspan="2">You can use this section to randomly generate authors using the editable First/Last Name lists below. This can help make your site look more active.</td></tr>

<tr><td><strong>First Name</strong></td><td><strong>Last Name</strong></td></tr>
<tr><td><textarea id="imwb_covertvideocontent_options[firstnames]" name="imwb_covertvideocontent_options[firstnames]" cols=38 rows=9>
<?php echo htmlspecialchars(stripslashes($this->options['firstnames'])) ?>
</textarea></td>
<td><textarea id="imwb_covertvideocontent_options[lastnames]" name="imwb_covertvideocontent_options[lastnames]" cols=38 rows=9>
<?php echo htmlspecialchars(stripslashes($this->options['lastnames'])) ?>
</textarea></td>
</tr>
<tr><td colspan="2">When updating settings generate <input type="text" name="imwb_covertvideocontent_options[genauthors]" value="0" size="3"> random authors</td></tr>
</table>
</div>

<?php 
$theme_name = IMWB_Covert_Video_Content_get_theme_name();

if($theme_name != "Covert VideoPress Theme") {
 ?>

<div class="sub_panel left" style="width:480px; clear: left;">
<h4>Theme Options</h4>
<div>
<P>You are running this plugin using a theme other than <a href="http://covertvideopress.com" target="_blank">Covert Video Press</a>. Here you can configure how the videos will display and run.</P>
<h3>Home, Archive & Category Page's</h3>
<p>Show video thumbnails:
<select id="imwb_covertvideocontent_options[showthumbs]" class="regular-text" type="text" name="imwb_covertvideocontent_options[showthumbs]" />
<?php 
 foreach ($yesno_options as $key => $value) {
    $selected = ($this->options['showthumbs'] == $key) ? " selected" : "";
    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
 }
?>
</select>
</p>
<p> Place video thumbnails 
<select id="imwb_covertvideocontent_options[thumbpos]" class="regular-text" type="text" name="imwb_covertvideocontent_options[thumbpos]" />
<?php 
 foreach ($leftright_options as $key => $value) {
    $selected = ($this->options['thumbpos'] == $key) ? " selected" : "";
    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
 }
?>
</select> of description.
</p>
<h3>Post Pages</h3>
<p>Autoplay Videos:
	<select id="imwb_covertvideocontent_options[autoplay]" class="regular-text" type="text" name="imwb_covertvideocontent_options[autoplay]" />
	<?php 
	 foreach ($yesno_options as $key => $value) {
       $selected = ($this->options['autoplay'] == $key) ? " selected" : "";
	    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
	 }
	?>
	</select>
</p>
<p> Place video
<select id="imwb_covertvideocontent_options[videopos]" class="regular-text" type="text" name="imwb_covertvideocontent_options[videopos]" />
<?php 
 foreach ($abovebelow as $key => $value) {
    $selected = ($this->options['videopos'] == $key) ? " selected" : "";
    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
 }
?>
</select> the post description.
</p>
<p>
Activate modest branding on YouTube Videos
<select id="imwb_covertvideocontent_options[ytmodestbrand]" class="regular-text" type="text" name="imwb_covertvideocontent_options[ytmodestbrand]" />
	<?php 
	 foreach ($yesno_options as $key => $value) {
       $selected = ($this->options['ytmodestbrand'] == $key) ? " selected" : "";
	    echo "<option value='{$key}'{$selected}>{$value['label']}</option>";
	 }
	?>
	</select>
</p>
</div>
</div>
<?php } ?>

<div class="submit">
<input class="button-primary" type="submit" name="update_imwb_covertvideocontentSettings" value="<?php _e('Update Settings', 'imwb_covertvideocontent') ?>" />
</div>
</form>
<iframe src="http://imwealthbuilders.com/wp_squeeze/promote.php?aid=0" width="815px" height="800px"></iframe>
 </div>
 </div>
 